package cn.ibizlab.businesscentral.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.humanresource.domain.Company;
import cn.ibizlab.businesscentral.core.humanresource.filter.CompanySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Company] 服务对象接口
 */
public interface ICompanyService extends IService<Company>{

    boolean create(Company et) ;
    void createBatch(List<Company> list) ;
    boolean update(Company et) ;
    void updateBatch(List<Company> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Company get(String key) ;
    Company getDraft(Company et) ;
    boolean checkKey(Company et) ;
    boolean save(Company et) ;
    void saveBatch(List<Company> list) ;
    Page<Company> searchDefault(CompanySearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Company> getCompanyByIds(List<String> ids) ;
    List<Company> getCompanyByEntities(List<Company> entities) ;
}


